#ifndef _EPD_CONFIG_H_
#define _DEV_CONFIG_H_
#define _EPD_CONFIG_H_

#include <Arduino.h>
#include <stdint.h>
#include <stdio.h>

/**
 * GPIO config
**/
#define EPD_SCK_PIN  14
#define EPD_MOSI_PIN 13
#define EPD_CS_PIN   5
#define EPD_RST_PIN  19
#define EPD_DC_PIN   0
#define EPD_BUSY_PIN 4

#define GPIO_PIN_SET   1
#define GPIO_PIN_RESET 0

/**
 * GPIO read and write
**/
#define DEV_Digital_Write(_pin, _value) digitalWrite(_pin, _value == 0? LOW:HIGH)
#define DEV_Digital_Read(_pin) digitalRead(_pin)


/*------------------------------------------------------------------------------------------------------*/
uint8_t DEV_Module_Init(void);
void DEV_SPI_WriteByte(uint8_t data);

#endif
